package blusunrize.immersiveengineering.common.blocks.metal;

import blusunrize.immersiveengineering.api.IEProperties;
import blusunrize.immersiveengineering.api.IPostBlock;
import blusunrize.immersiveengineering.client.models.IOBJModelCallback;
import blusunrize.immersiveengineering.common.blocks.BlockIETileProvider;
import blusunrize.immersiveengineering.common.blocks.ItemBlockIEBase;
import blusunrize.immersiveengineering.common.blocks.wooden.TileEntityWallmount;
import blusunrize.immersiveengineering.common.blocks.wooden.TileEntityWoodenPost;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyEnum;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.BlockRenderLayer;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumFacing.Axis;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.common.property.Properties;

import java.util.ArrayList;
import java.util.List;

public class BlockMetalDecoration2 extends BlockIETileProvider<BlockTypes_MetalDecoration2> implements IPostBlock
{
	public BlockMetalDecoration2()
	{
		super("metal_decoration2", Material.field_151573_f, PropertyEnum.func_177709_a("type", BlockTypes_MetalDecoration2.class), ItemBlockIEBase.class, IEProperties.FACING_ALL,IEProperties.MULTIBLOCKSLAVE,IEProperties.INT_4, Properties.AnimationProperty, IOBJModelCallback.PROPERTY, IEProperties.CONNECTIONS);
		this.func_149711_c(3.0F);
		this.func_149752_b(15.0F);
		this.setAllNotNormalBlock();
		this.setMetaBlockLayer(BlockTypes_MetalDecoration2.RAZOR_WIRE.getMeta(), BlockRenderLayer.CUTOUT);
		field_149786_r = 0;
	}

	@Override
	public List<ItemStack> getDrops(IBlockAccess world, BlockPos pos, IBlockState state, int fortune)
	{
		if(this.func_176201_c(state)==BlockTypes_MetalDecoration2.ALUMINUM_POST.getMeta()||this.func_176201_c(state)==BlockTypes_MetalDecoration2.STEEL_POST.getMeta())
			return new ArrayList<>();
		return super.getDrops(world, pos, state, fortune);
	}
	@Override
	public void func_180663_b(World world, BlockPos pos, IBlockState state)
	{
		TileEntity tileEntity = world.func_175625_s(pos);
		if(tileEntity instanceof TileEntityWoodenPost)
		{
			if(!((TileEntityWoodenPost)tileEntity).isDummy() && !world.field_72995_K && world.func_82736_K().func_82766_b("doTileDrops") && !world.restoringBlockSnapshots)
				world.func_72838_d(new EntityItem(world, pos.func_177958_n()+.5,pos.func_177956_o()+.5,pos.func_177952_p()+.5, new ItemStack(this,1,this.func_176201_c(state))));
		}
		super.func_180663_b(world, pos, state);
	}

	@Override
	public boolean isSideSolid(IBlockState state, IBlockAccess world, BlockPos pos, EnumFacing side)
	{
		TileEntity te = world.func_175625_s(pos);
		if(te instanceof TileEntityWoodenPost)
		{
			return ((TileEntityWoodenPost)te).dummy==0?side==EnumFacing.DOWN: ((TileEntityWoodenPost)te).dummy==3?side==EnumFacing.UP: ((TileEntityWoodenPost)te).dummy>3?side.func_176740_k()==Axis.Y: side.func_176740_k()!=Axis.Y;
		}
		return super.isSideSolid(state, world, pos, side);
	}

	@Override
	public boolean canIEBlockBePlaced(World world, BlockPos pos, IBlockState newState, EnumFacing side, float hitX, float hitY, float hitZ, EntityPlayer player, ItemStack stack)
	{
		if(stack.func_77952_i()== BlockTypes_MetalDecoration2.STEEL_POST.getMeta() || stack.func_77952_i()== BlockTypes_MetalDecoration2.ALUMINUM_POST.getMeta())
		{
			for(int hh=1; hh<=3; hh++)
				if(!world.func_180495_p(pos.func_177982_a(0,hh,0)).func_177230_c().func_176200_f(world, pos.func_177982_a(0,hh,0)))
					return false;
		}
		return true;
	}

	@Override
	public boolean isLadder(IBlockState state, IBlockAccess world, BlockPos pos, EntityLivingBase entity)
	{
		return (world.func_175625_s(pos) instanceof TileEntityWoodenPost);
	}

	@Override
	public TileEntity func_149915_a(World worldIn, int meta)
	{
		switch(BlockTypes_MetalDecoration2.values()[meta])
		{
			case STEEL_POST:
				return new TileEntityWoodenPost();
			case STEEL_WALLMOUNT:
				return new TileEntityWallmount();
			case ALUMINUM_POST:
				return new TileEntityWoodenPost();
			case ALUMINUM_WALLMOUNT:
				return new TileEntityWallmount();
			case LANTERN:
				return new TileEntityLantern();
			case RAZOR_WIRE:
				return new TileEntityRazorWire();
			case TOOLBOX:
				return new TileEntityToolbox();
		}
		return null;
	}

	@Override
	public boolean canConnectTransformer(IBlockAccess world, BlockPos pos)
	{
		IBlockState state = world.func_180495_p(pos);
		BlockTypes_MetalDecoration2 type = state.func_177229_b(property);
		boolean slave = state.func_177229_b(IEProperties.MULTIBLOCKSLAVE);
		return slave&&(type==BlockTypes_MetalDecoration2.STEEL_POST||type==BlockTypes_MetalDecoration2.ALUMINUM_POST);
	}

	@Override
	public boolean allowHammerHarvest(IBlockState state)
	{
		return true;
	}

	@Override
	public boolean allowWirecutterHarvest(IBlockState state)
	{
		return func_176201_c(state)==BlockTypes_MetalDecoration2.RAZOR_WIRE.getMeta();
	}
}
